; Claen/Oefler, Wissensspeicher Mikrorechner-Programmierung, S. 172-180

;AS-Funktionen
hi              function x,(x>>8)&255
lo              function x, x&255


		cpu	z8601
		include	stddefz8.inc
		page	0

		org	800h
		assume RP:0C0h		; keine Optimierung durch AS

		db	12h dup 0FFh

    ; MOEGLICHES ANWENDERPROGRAMM IM EXT. SPEICHER 
INTERNAL
EINTRITT:    
		org	812h		; EINTRITTSPUNKTE
            JP BEGIN
            JP GET_CHAR
            JP PUT_CHAR

    ; INITIALISIERUNG UND AUFRUF DES INTERPRETERS 

BEGIN:
            LD R8,#10010110b  ; NORMAL EXT. TIMING 
            LD SPL,#80h
            LD T0,#40h          ; TIMER FUER 300 BAUD 
            LD P3M,#01001001b	; orig 49h, orig Hexlisting 41h (DM nicht negiert)
            LD PRE0,#00001101b
            LD TMR,#01000011b
            CLR IMR
            EI
            LD 6,#hi(BASICPROGRAMM)
            LD 7,#lo(BASICPROGRAMM)
            CLR 8           ; KEINE EXT. PROZEDUR 
            CLR 9
            LD SIO ,#'#'    ; PROMPT-ZEICHEN  
            CALL 07FDh       ; BASIC INTERPRETER 
            JR BEGIN

    ; ZEICHEN HOLEN BZW. SENDEN
    ; FERNSCHREIBER MIT FULL-DUPLEX 

GET_CHAR:
            AND IRQ,#0F7h    ; ALTEN REQUEST RUECKS. 
GTC10:      TM IRQ,#8      ; ZEICHEN DA ?          
            JR Z,GTC10
            AND IRQ,#0F7h    ; REQUEST RUECKSETZEN   
            LD R8,SIO
            AND R8,#7Fh     ; PARITAET RUECKSETZEN  

PUT_CHAR:
            TM IRQ,#10h     ; LETZTES ZEICHEN RAUS? 
            JR Z, PUT_CHAR
            AND IRQ,#0EFh   ; REQUEST RUECKSETZEN   
            LD SIO,R8
            CP R8,#'\r'
            JR Z,PTC10
            RET
PTC10:      LD R8,#'\n'
            CALL PUT_CHAR   ; AUTO LINEFEED         
            LD R8,#'\r'
            RET

    ; BEGINN DES BASICPROGRAMMS 
BASICPROGRAMM: equ $

	END


Basic-Teil in JTCEMU in Editor geladen, F9 auf Adresse E069
0 Fehler
BASIC-Programm in Speicherbereich E069-E41E geladen
Speichern als BIN: E069-E41E
beide Teile zusammenkopieren:
copy /b u88x-emr-bespiel.bin+u88x-emr-bespiel.bin emr-bespiel.bin
